//  3d-Overlay for Intro Maniac by Epyx
// Attention, dont load a Background Picture to see a effect
// May lock the Mouse Position to stop object movement   ->   (extra/setup menu)

uniform float time;
uniform float2 mouse;

float4 clear = float4(0.0f, 0.0f, 0.0f, 0.0f);
texture texture0;   sampler postTex = sampler_state  {  texture = (texture0);    };


float4 MyShader (float2 Tex : TEXCOORD) : COLOR
{   float4 color4  = tex2D(postTex ,   float2( Tex.x,  Tex.y  )); // original sichern
     float4 gl_FragColor = float4(0.0f, 0.0f, 0.0f, 0.0f);
    float2 p = -1.0 + 2.0 * Tex.xy;
    float2 m = -1.0 + 2.0 * mouse.xy; 

    float a1 = atan2(p.y-m.y,p.x-m.x);
    float r1 = sqrt(dot(p-m,p-m));
    float a2 = atan2(p.y+m.y,p.x+m.x);
    float r2 = sqrt(dot(p+m,p+m));

    float2 uv;
    uv.x = 0.2*time + (r1-r2)*0.25;
    uv.y = sin(2.0*(a1-a2));

    float w = r1*r2*0.8;
    float3 col = tex2D(postTex,uv).xyz;

    float4 color = float4(col/(.1+w),1.0); 

    if (color4.r   == clear.r  )  {  gl_FragColor.r  = color.r;   } else { gl_FragColor.r = color4.r;  }
    if (color4.g  == clear.g )  {  gl_FragColor.g = color.g;  } else { gl_FragColor.g = color4.g; }
    if (color4.b  == clear.b )  {  gl_FragColor.b = color.b;  } else { gl_FragColor.b = color4.b; }

    return gl_FragColor;  }


// ---------------------------------------------
// Vertex Shader

struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;

    OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------

technique PostProcess
{
    pass p1
    {
       // Lighting = True;
       VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 MyShader();
    }

}
