float4x4 worldViewProjI; float postfx;

//original author = 
//fork by harley : repeat gears over x/y axis, add more colors
// funny ;)
//  3d-Overlay for Intro Maniac by Epyx
// Attention, dont load a Background Picture to see a effect


uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2( 320,  240 ) ; // Screensize <-------- Hier kann man mehr oder weniger Zahnrder auf dem Bildschirm einstellen
float4 clear = float4(0.0f, 0.0f, 0.0f, 0.0f);
texture texture0;   sampler postTex = sampler_state  {  texture = (texture0);    };



float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
               float4 color4  = tex2D(postTex ,   float2( gl_FragCoord.x,  gl_FragCoord.y  )); // original sichern
               gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;
	float2 distanceVector = (gl_FragCoord.xy / resolution.xy);
	distanceVector.x *= resolution.x;
	distanceVector.y *= resolution.y;
	
	float d = 50.0;
	
	float newtime = time * sign(fmod(distanceVector.x, d * 2.0) - d) * sign(fmod(distanceVector.y, d * 2.0) - d);
	
	distanceVector.x = fmod(distanceVector.x, d) - d / 2.0;	
	distanceVector.y = fmod(distanceVector.y, d) - d / 2.0;
	
	float angle = atan2(distanceVector.x, distanceVector.y);
	
	float scale = 0.0014;   // hier sind einstellungen fr das Zahnrad aussehen
	float cogMin = 0.06;    // 'min' is actually the outer edge because I'm using 1/distance... for reasons I can't remember :(
	float cogMax = 0.97;   // 'max' is the inner edge, so this controls the size of the hole in the middle - the higher the value the smaller the hole


	float distance = 1.0 - scale * ((distanceVector.x * distanceVector.x) + (distanceVector.y * distanceVector.y));

	
	// tooth adjust makes the teeth slope so they get smaller as they get further out
	float toothAdjust = 2.4 * (distance - cogMin);
	// 12 defines the number of cog teeth
	float angleFoo = sin(angle*12.0 - newtime * 4.0) - toothAdjust;
	cogMin += 20.0 * clamp(1.0 * (angleFoo + 0.2), 0.0, 1.015); // add 0.2 to make teeth a bit thinner, the 0.015 clamp controls the thickness of the cog ring
	
	// By multiplying values up and clamping we can get a solid cog with slight anti-aliasing
	float isSolid = clamp(2.0 * (distance - cogMin) / cogMax, 0.0, 1.0);
	isSolid = clamp(isSolid * 100.0 * (cogMax - distance), 0.0, 1.0);
	
	// Make it BlitzTech silver	
	float brightness = isSolid *(1.0-sin(angle*3.0-newtime)*0.5);
	float4 col = float4(brightness*0.5 , brightness*0.5 , brightness*0.5 * sign(newtime), 1.0 ); // <-- Farbe Zahnrad  RGB = 0.5
        
               if (color4.r   == clear.r  )  {  gl_FragColor.r  = col.r;   } else { gl_FragColor.r = color4.r;  }
               if (color4.g  == clear.g )  {  gl_FragColor.g = col.g;  } else { gl_FragColor.g = color4.g; }
               if (color4.b  == clear.b )  {  gl_FragColor.b = col.b;  } else { gl_FragColor.b = color4.b; }

 return gl_FragColor;   }


// Vertex Shader
struct VS_INPUT
{   float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;   };

struct VS_OUTPUT
{    float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;    };


VS_OUTPUT myvs( VS_INPUT IN )
{  VS_OUTPUT OUT;
     OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
     OUT.texture0 = IN.texture0;
return OUT;   }


// ---------------------------------------------
technique Start
{  pass p1   {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
}   }




