float4x4 worldViewProjI; 

// Plane deformations
// by Anton Platonov <platosha@gmail.com>
// twitter.com/platosha
// Trippy variation by bzdzb
//  Moved to HLSL and 3d-Overlay for Intro Maniac by Epyx

// Attention, dont load a Background Picture to see a effect



uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(933,511) ; // Screensize;

float4 clear = float4(0.0f, 0.0f, 0.0f, 0.0f);
texture texture0;
sampler postTex = sampler_state
{  texture = (texture0);    };



float TAU = 6.2832;



float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
                
                float4 color4  = tex2D(postTex ,   float2( gl_FragCoord.x,  gl_FragCoord.y  )); // original sichern
                gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;

	float2 position = ( gl_FragCoord.xy / resolution.xy );
	float2 p = -1.0 + 2.0 * position;
	p *= float2( resolution.x/resolution.y, 1.0 );
	
	float alpha = -time * 0.13;
	float sinA = sin(alpha), cosA = cos(alpha);
	p = float2(cosA*p.x+sinA*p.y, -sinA*p.x+cosA*p.y);
	
	float2 q = p;
	float2 dir = float2( sin(time*0.19), cos(time*0.27) ) * 0.333;
	q = p + dir/pow(0.5, 0.6-dot(p-dir,p-dir));
	
	q = lerp(q, p, sin(time*0.78));
	
	float zr = 1.0/length(q);
	float zp = 1.0/abs(q.y);
	float mc = sin(time*0.16)*.5 + .5;
	mc = smoothstep(0.0, 1.0, mc);
	mc = smoothstep(0.0, 1.0, mc);
	mc = smoothstep(0.0, 1.0, mc);
	mc = smoothstep(0.0, 1.0, mc);
	float z = lerp(zr, zp, mc);
	float ur = 5.0*atan2(q.x*sign(q.y), abs(q.y)) + cos(z*cos(z*z*time)*TAU+time) * z * sin( time );
	float up = q.x*z;
	float u = lerp(ur, up, mc);
	float2 uv = float2(u, (1.0+mc*2.0)*z*z);
	
	float mv = sin(time * 0.0);
	uv = lerp(uv, q, 0.0);
	
	float color = 0.0;
	color = tan(uv.x*TAU) * tan(uv.y*TAU + time*7.7);
	color = pow(abs(cos(color*TAU)), 3.0);
	
	float color2 = 0.0;
	color2 = sin(uv.x*TAU*2.0) + tan(color2);
	color2 -= 0.55;
		
	float shadow = 1.0/(z*z);
	float3 rc = float3(0.9, 0.9, 2.0)*color +
		  float3(sin(time), cos(time), cos(8.0))*color2;
	rc *= shadow;
	
	float4 col = float4( rc, 1.0 );
                

               if (color4.r   == clear.r  )  {  gl_FragColor.r  = col.r;   } else { gl_FragColor.r = color4.r;  }
               if (color4.g  == clear.g )  {  gl_FragColor.g = col.g;  } else { gl_FragColor.g = color4.g; }
               if (color4.b  == clear.b )  {  gl_FragColor.b = col.b;  } else { gl_FragColor.b = color4.b; }

 return gl_FragColor; }





// Vertex Shader
struct VS_INPUT
{   float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;  };




struct VS_OUTPUT
{    float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;  };




VS_OUTPUT myvs( VS_INPUT IN ) {
    VS_OUTPUT OUT;

    OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
  
    OUT.texture0 = IN.texture0;
    return OUT;   }


// ---------------------------------------------


technique Start {
    pass p1  {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}

