// PS 3.0 version Squaretunnel
// 3d Overlay for Intro Maniac by Epyx

// Attention, dont load a Background Picture to see a effect
// Load Texture 2 to skin Postshader Effect

uniform float time;
float4 mouse = float4(0.1,0.1,0,0);
float4 clear = float4(0.0f, 0.0f, 0.0f, 0.0f);



texture texture0;   sampler postTex = sampler_state {  Texture = <texture0>; };
texture texture2;   sampler proTex  = sampler_state  {  Texture = <texture2>; };



float4 MyShader (float2 Tex : TEXCOORD) : COLOR
{
    float4 color4  = tex2D(postTex ,   float2( Tex.x,  Tex.y  )); // original sichern
    float4 TexColor = float4(0.0f, 0.0f, 0.0f, 0.0f);
    float2 p = -1.0 + 2.0 * Tex.xy;
    float2 uv;

    float r = pow( pow(p.x*p.x,16.0) + pow(p.y*p.y,16.0), 1.0/32.0 );
    uv.x = .5*time + 0.5/r;
    uv.y = 1.0*atan2(p.y,p.x)/3.1416;

    float3 col =  tex2D(proTex  ,uv).xyz;
    float4 Color = float4(col*r*r*r,1.0); 

    if (color4.r   == clear.r  )  {  TexColor.r  = Color.r;   } else { TexColor.r  = color4.r; }
    if (color4.g  == clear.g )  {  TexColor.g = Color.g;  } else { TexColor.g = color4.g; }
    if (color4.b  == clear.b )  {  TexColor.b = Color.b;  } else { TexColor.b = color4.b; }

    return TexColor;  }

// ---------------------------------------------
// Vertex Shader

struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;

    OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------

technique PostProcess
{
    pass p1
    {
       // Lighting = True;
       VertexShader = compile vs_2_0 myvs();
        PixelShader = compile ps_2_0 MyShader();
    }

}
