float4x4 worldViewProjI; float postfx;

uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(800, 600) ; // Screensize;

float4 pal(float t) {
	return float4(
		sin(t/2.0)+cos(t/5.76+14.5)*0.5+0.5,
		sin(t/2.0)+cos(t/4.76+14.5)*0.5+0.4,
		sin(t/2.0)+cos(t/3.76+14.5)*0.5+0.3,
		1.0);
}

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;

	float2 pos = gl_FragCoord.xy / resolution;
	float aspect = resolution.x / resolution.y;

	float rand = fmod(frac(sin(dot(pos + time, float2(12.9898,100.233))) * 43758.5453), 1.0) *  0.01;
	rand += .8 * (1. - (length((pos - (1.0 -mouse)) * float2(aspect, 1.)) * 8.));
                rand *= 1.8 * (1. - (length((pos - mouse) * float2(aspect, 1.)) * (2.0+sin(time*1.0)*2.0)));

	//gl_FragColor = float4( sin(rand*4.0), cos(rand*0.3), sin(10.0+rand*10.0), 1.0);
	gl_FragColor=pal(rand*4.0);
            return gl_FragColor;

}
// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 10) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}



// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}


