float4x4 worldViewProjI; float postfx;
// @mod* rotwang

uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(633,511) ; // Screensize;

float rand(float2 co){
    return frac(sin(dot(co.xy ,float2(0,0))) * 431.5453);
}

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR
{
gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;

	float tmin = time*10.25;
	float usint = sin(tmin)*0.5+0.5;
	float2 pos = -1.0 + 2.0 * gl_FragCoord.xy / resolution;
	pos.x *= ((sin(time/10)*200) / 300 );
	
	float u = length(pos)*2.0;
	float v = atan2(pos.y, pos.x);
	float t = tmin + 8.0 / u;
	
	float3 color = (abs (sin (t * 4.0 + v) ) ) * u* 0.25;
	
               color += (abs(sin(t - v))) * u * 0.29;
	
	color.y *= 0.6;
	color.z *= 0.2;
	color.yz *= rand(float2(t, v)) +u*u;
	
	gl_FragColor = float4(color, 1.0);
            return gl_FragColor;

}

// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}
