float4x4 worldViewProjI; float postfx;

uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(933,511) ; // Screensize;

// static float2 position;
static float3 color;

float barsize = 0.11;
float barsangle = 1.4;

float3 mixcol(float value, float r, float g, float b)
{
return float3(value * r, value * g, value * b);
}

void bar(float2 position, float pos, float r, float g, float b)
{
if ((position.y <= pos + barsize) && (position.y >= pos - barsize))
color = mixcol(1.0 - abs(pos - position.y) / barsize, r, g, b);
}

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
if (postfx == 1) gl_FragCoord.x = gl_FragCoord.x + 0.23;

gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;

float2 position = ( gl_FragCoord.xy / resolution.xy );
position = position * float2(2,2) - float2(1,1); 

float t = fmod(time * 0.1, 10.) + time;

bar(position ,sin(t), 1, 0, 0);
bar(position ,sin(t+barsangle/6.), 1, 1, 0);
bar(position ,sin(t+barsangle/6.*2.), 0, 1, 0);
bar(position ,sin(t+barsangle/6.*3.), 0, 1, 1);
bar(position ,sin(t+barsangle/6.*4.), 0.5, 0, 1);
bar(position ,sin(t+barsangle/6.*5.), 1, 0, 1);

return float4(color, 1.0);
}

technique Start
{
pass p1 
{
PixelShader = compile ps_2_0 main();
}
}

