float4x4 worldViewProjI; float postfx;
//Edit @ToBSn

 
uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(1,1);

float getValue(float2 p, float x2, float y2, float cmin, float cmax)
{
  float x=p.x;
  float y=p.y;
  float theta=dot(y-y2, x2);
  float2 d = float2(-cos(theta * x2), cos(theta - cmin));
  d *= sin(time * 0.1) * (cmax-cmin) + cmin;
  d += float2(y, x) + length(p) * distance(y,x);
  d *= float2(x, y) * cos(p * time * 0.1) * dot(x,y);
  return length(d-p);
}

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {

	float2 position = ( gl_FragCoord.xy / resolution.xy ) * 2.0 - float2(1.0,resolution.y/resolution.x);
  	position = position * 5.0 ;

  	float a = sin(time*.5+position.x);
  	a += getValue(position, sin(time)*.1, cos(time)*.2, 5.3, 0.8);
    	a *= getValue(position, sin(time)*.1, cos(time)*.2, 5.3, 0.8);
  	a += getValue(position, sin(time)*.1, cos(time)*.2, 5.3, 0.8);
  	a /= getValue(position, sin(time)*.1, cos(time)*.2, 5.3, 0.8);
  	a = 1./a;
  
  	float b = sin(time+position.y*1.5);
  	b += getValue(position, cos(time)*.1, sin(time)*.2, 5.3, 0.8);
    	b *= getValue(position, cos(time)*.1, sin(time)*.2, 5.3, 0.8);
  	b += getValue(position, cos(time)*.1, sin(time)*.2, 5.3, 0.8);
  	b /= getValue(position, cos(time)*.1, sin(time)*.2, 5.3, 0.8);
  	b = 1./b;
  
  	float c = sin(time*.8+length(position)*8.0);
  	c += getValue(position, sin(time)*.1, cos(time)*.2, 5.3, 0.8);
    	c *= getValue(position, sin(time)*.1, cos(time)*.2, 5.3, 0.8);
  	c += getValue(position, sin(time)*.1, cos(time)*.2, 5.3, 0.8);
  	c /= getValue(position, sin(time)*.1, cos(time)*.2, 5.3, 0.8);
  	c = 1./c;
  
	gl_FragColor = float4( a, b, c, 1.0 );
            return gl_FragColor;

}

// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}

