// 'Water' by Viktor Korsun (BIT_TEK) (2012)

texture texture0;
sampler tex0 = sampler_state
{ Texture = <texture0>;  };
uniform float time;
uniform float2 resolution	= float2(933,511) ;
float PI			= 3.1415926535897932;


//speed
  float speed 	= 0.2;
  float speed_x 	= 0.3;
  float speed_y 	= 0.3;

// geometry
  float intensity 	= 3.;
  int steps 	= 8;
  float frequency 	= 4.0;
  int angle 	= 7;


// reflection and emboss
  float delta 	= 20.;
  float intence 	= 400.;
  float emboss 	= 0.3;


//---------- crystals effect
float col(float2 coord)
{   float delta_theta = 2.0 * PI / float(angle);
    float col = 0.0;
    float theta = 0.0;
    for (int i = 0; i < steps; i++)

    { float2 adjc = coord;
      theta = delta_theta*float(i);
      adjc.x += cos(theta)*time*speed + time * speed_x;
      adjc.y -= sin(theta)*time*speed - time * speed_y;
      col = col + cos( (adjc.x*cos(theta) - adjc.y*sin(theta))*frequency)*intensity;  }

    return cos(col);  }




float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
gl_FragCoord.y = 1 - gl_FragCoord.y; gl_FragCoord = gl_FragCoord * resolution;

float2 p = (gl_FragCoord.xy) / resolution.xy, c1 = p, c2 = p;
float cc1 = col(c1);

c2.x += resolution.x/delta;
float dx = emboss*(cc1-col(c2))/delta;
c2.x = p.x;
c2.y += resolution.y/delta;
float dy = emboss*(cc1-col(c2))/delta;
c1.x += dx;
c1.y = -(c1.y+dy);
float alpha = 1.+dot(dx,dy)*intence;
gl_FragColor = tex2D(tex0,c1)*(alpha);
return gl_FragColor;   }


// Vertex Shader
struct VS_INPUT
{   float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;  };

struct VS_OUTPUT
{    float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;  };

VS_OUTPUT myvs( VS_INPUT IN )
{   VS_OUTPUT OUT;
    OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    OUT.texture0 = IN.texture0;
    return OUT;   }


technique Start
{  pass p1  
    {   VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();    }
}

