float4x4 worldViewProjI; float postfx;
// the.savage@hotmail.co.uk


uniform float2 resolution = float2(1,1);
uniform float2 mouse;

uniform float time;

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR
{
	float2 vPixel=gl_FragCoord.xy;

	float2 vScreen=resolution;
	float2 vMouse=float2(0.1,0.1)+mouse;

	float fTime=time*0.5;

	float3 v=float3(
		vPixel.x+vPixel.y+cos(sin(fTime)*2.0)*100.0+sin(vPixel.x/100.0)*100.0,
		vPixel.y/vScreen.y/(vMouse.x*5.0)+fTime,
		vPixel.x/vScreen.x/(vMouse.y*5.0));
	
	float r=abs(sin(v.y+fTime)/2.0+v.z/2.0-v.y-v.z+fTime);
	float g=abs(sin(r+sin(v.x/1000.0+fTime)+sin(vPixel.y/100.0+fTime)+sin((vPixel.x+vPixel.y)/100.0)*3.0));
	float b=abs(sin(g+cos(v.y+v.z+g)+cos(v.z)+sin(v.x/1000.0)));

	float2 p=-1.0+2.0*vPixel/vScreen;
	float w=0.5+0.5*(sin(fTime+4.0*sqrt(dot(p,p)))+0.5*cos(fTime+5.0*atan2(p.y,p.x)));

	gl_FragColor=float4(1.0-(float3(r,g,b)*w),1.0);
            return gl_FragColor;

}

// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}

