float4x4 worldViewProjI; float postfx;

uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(1,1);

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
	float2 position = ( gl_FragCoord.xy / resolution.xy );

	float color = 0.0;

  // sin(sqrt(x^2 + y^2)) / sqrt(x^2 + y^2)
  
  	float ox = resolution.x / 2.0;
  	float oy = resolution.y / 2.0;
  
  	float px = 50.0 - ((position.x) * 100.0);
  	float py = 50.0 - ((position.y) * 100.0);

   	float px2 = 25.0 - ((position.x) * 100.0) + sin(time)*10.0;
  	float py2 = 25.0 - ((position.y) * 100.0) + cos(time)*20.0;
 
  	float d =sqrt (px*px +py*py);
  	float d2 =sqrt (px2*px2 +py2*py2);
  
  	color = sin( d * (d/(155.0+ sin(time)*10.0))+ time*0.0) / (d/8.0);
  	color += sin( d2 * (d2/(155.0 + sin(time)*20.0))) / (d2/8.0);

	float c2 = (color >0.2 && color< 0.3) ? 0.4 : 0.0;
  	color = color > 0.5 ? 1.0 : 0.0;
  	color += c2;
	gl_FragColor = float4( float3( color, color, color )  , 1.0 );
            return gl_FragColor;


}


// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}
