uniform float   time;
uniform float2 mouse;
uniform float2 resolution = float2(1,1);

float orbitDistance = 0.225;
float waveLength =  120.;

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
	float2 p1 = (float2(sin(time), cos(time))*orbitDistance)+0.5;
	float2 p2 = (float2(sin(time+3.142), cos(time+3.142))*orbitDistance)+0.6;

	float d1 = 1.-length(gl_FragCoord.xy/resolution -p1);
	float d2 = 1.-length(gl_FragCoord.xy/resolution -p2);

	float wave1 = sin(d1*waveLength+(time*5.))*0.5 + 0.5 * (((d1 - 0.5) * 2.) + 0.5);
	float wave2 = sin(d2*waveLength+(time*5.))*0.5 + 0.5 * (((d1 - 0.5) * 2.) + 0.5);
	float c = d1 > 0.99 || d2 > 0.99 ? 0. : 0.;
	c + wave1*wave2;
	gl_FragColor = float4(c + wave1*wave2,  (c + wave1*wave2)/1.9 , 0  ,   1);
            return gl_FragColor;


} 
technique Start
{
    pass p1  
    {
        PixelShader = compile ps_2_0 main();
    }
}
