float4x4 worldViewProjI; float postfx;


//tweaks, anony_gt
uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(1,1);

uniform sampler2D backbuffer;

float orbitDistance = 0.000025;
float waveLength = 300.00;

//.h
float3 sim(float3 p,float s);
float2 rot(float2 p,float r);
float2 rotsim(float2 p,float s);

//nice stuff :)
float2 makeSymmetry(float2 p){
  float2 ret=p;
  ret.y=abs(ret.y);
  ret=rotsim(ret,sin(time*0.1)*2.0+9.0); 
  ret.x=abs(ret.x);
  return ret;
}


//util functions
const float PI=3.14159265;

float3 sim(float3 p,float s){
   float3 ret=p;
   ret=p+s/2.0;
   ret=frac(ret/s)*s-s/2.0;
   return ret;
}

float2 rot(float2 p,float r){
   float2 ret;
   ret.x=p.x*cos(r)-p.y*sin(r);
   ret.y=p.x*sin(r)+p.y*cos(r);
   return ret;
}

float2 rotsim(float2 p,float s){
   float2 ret=p;
   ret=rot(p,-PI/(s*2.0));
   ret=rot(p,floor(atan2(ret.x,ret.y)/PI*s)*(PI/s));
   return ret;
}
//Util stuff end

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
	float2 uv = (gl_FragCoord.xy/resolution.x)*2.0-float2(1.0,resolution.y/resolution.x);
 	uv=uv*.2;
  
  	 uv=makeSymmetry(uv);
                float2 p1 = (float2(sin(time), cos(time))*orbitDistance)+.1;
	float2 p2 = (float2(sin(time+3.142), cos(time+3.142))*orbitDistance)+.125;

	float d1 = .1-length(uv +p1);
	float d2 = .1-length(uv -p2);

	float wave1 = sin(d1*waveLength+(time*5.))*0.5 + 0.5 * (((d1 - 0.5) * .5) - .5);
	float wave2 = sin(d2*waveLength+(time*5.))*0.5 + 0.5 * (((d1 - 0.5) * 1.5) + 1.5);
	float c = d1 > 0.99 || d2 > 0.995 ? 1. : 0.;
	c + wave1*wave2;
	gl_FragColor = float4(c + wave1*wave2,c,c,1.);

	// "bumpmapping" @Flexi23
	float2 d = 1./resolution;
	float dx = tex2D(backbuffer, uv + float2(-1.,0.)*d).x - tex2D(backbuffer, uv + float2(1.,0.)*d).x ;
	float dy = tex2D(backbuffer, uv + float2(0.,-1.)*d).x - tex2D(backbuffer, uv + float2(0.,1.)*d).x ;
	d = float2(dx,dy)*resolution/resolution.x*2.;
	gl_FragColor.z = pow(clamp(1.-1.5*length(uv  - float2(1.15*cos(time*.2)+.5,1.*sin(time*.1)+.5) + d),0.,1.),4.0);
	gl_FragColor.y = gl_FragColor.z*1.5 + gl_FragColor.x*0.3;

	gl_FragColor *=10.25;
            return gl_FragColor;


}
// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}
