float4x4 worldViewProjI; float postfx;
#ifdef GL_ES
// precision mediump float;
#endif
#define pi 3.141592653589793238462643383279

uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(1,1);

// How fast it animates
float tscale = 1.0;

float wave(float2 position, float freq, float height, float speed) {
	float result = sin(position.x*freq - time*tscale*speed);
	result = result * mouse.y * 5.0 - 1.0;
	result *= height;
	return result;
}

float3 combo(float2 position, float center, float size) {
	
	float offset = pi * (center * 8.9);
	float lum   = abs(tan(position.y * pi + offset)) - pi/100.9;
	lum *= size;
	
        float red   = wave(position, 10.0, 0.9*size, 1.008);
	float green = wave(position, 10.5, 0.5*size, -0.023);
	float blue  = wave(position, 10.5, 0.2*size, 1.042);
	
	return float3( lum + red, lum + green, lum + blue );
}

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR {
	// normalize position
	float2 position = gl_FragCoord.xy / resolution.xy;
	
	float3 result = float3(0.0, 0.0, 0.0);
	result += combo(position, 0.1+0.05*sin(0.6*time + 4.0*position.x), 0.05);
	result += combo(position, 0.5+0.05*sin(0.9*time + (2.0)*position.x), 0.25);
	result += combo(position, 0.85+0.05*sin(0.42*time + 1.3*position.x), 0.05);
//result +=         combo(position, 0.02+0.05*sin(0.012*time + 6.3*position.y), -0.5);

	
	gl_FragColor = float4(result, 1.0);
            return gl_FragColor;


}

// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}