// Reflectionshader by Epyx
float4x4 worldViewProj   : WorldViewProjection;  //  wvp
float4x4 matWorld : World;   // world

float3 vecEye : CAMERAPOSITION;
float4 tint = float4(1,1,1,1);

struct VS_IN
{
	float4 Position : POSITION;
	float3 Normal : NORMAL;	
};
struct VS_OUT
{
	float4 Position : POSITION;
	float3 Reflect  : TEXCOORD0;    
};
struct PS_OUT
{
	float4 Color : COLOR;
};

texture texture0;
samplerCUBE CubeMap = sampler_state 
{ 
    texture = <texture0> ;     
};

float4 CubeMapLookup(float3 CubeTexcoord)
{    
    return texCUBE(CubeMap, CubeTexcoord);
}

VS_OUT VS_Reflection(VS_IN input)
{
	VS_OUT output = (VS_OUT)0;
	
	output.Position = mul(input.Position, worldViewProj);	
	
	float3 Normal        = mul(normalize(input.Normal), matWorld);   
                float3 PosWorldr     = (mul(input.Position, matWorld));
                float3 ViewDirection = normalize(PosWorldr - vecEye);
	
	output.Reflect = reflect(ViewDirection, Normal);	
	
	return output;
}
PS_OUT PS_Reflection(VS_OUT input)
{
	PS_OUT output = (PS_OUT)0;
	
	output.Color = CubeMapLookup(input.Reflect) * tint;
	
	return output;
}

technique Reflection
{
	pass Pass0
	{
		VertexShader = compile vs_2_0 VS_Reflection();
		PixelShader  = compile ps_2_0 PS_Reflection();
	}
}