float4x4 worldViewProjI; float postfx;
#ifdef GL_ES
// precision mediump float;
#endif

uniform float time;
uniform float2 mouse;
uniform float2 resolution = float2(1,1);

float rand(float2 co)
{
	return frac(sin(dot(co.xy ,float2(12.9898,78.233))) * 43758.5453);
}

float3 core(float2 pos)
{
	if(length(pos) > 0.4) return float3(0.0,0.0,0.0);
	
	return float3(1.0, 0.6, 0.0);
}

float3 glow(float2 pos)
{
	if(length(pos) > 0.6) return float3(0.0,0.0,0.0);
	
	float grad = (0.6 - length(pos)) / 0.6;
	return float3(grad, grad * 0.6, 0.0) * (sin(time) * 0.2 + 0.8) * 1.2;
}

float3 rays(float2 pos)
{
	if(sin(atan2(pos.y, pos.x) * 10.0 + sin(time)) > 0.0 && length(pos) < 0.9)
	{
		float grad = (0.9 - length(pos)) / 0.9;
		return float3(grad, grad * 0.6, 0.0) * (sin(time) * 0.2 + 0.8) * 0.1;
	}
	return float3(0.0,0.0,0.0);
}

float4 main(float2 gl_FragCoord: TEXCOORD0, float4 gl_FragColor: COLOR ) : COLOR
{
	float2 uv = -1.0 + 2.0 * gl_FragCoord.xy / resolution;
	uv.x *= (resolution.x / resolution.y);
	
	float3 color = float3(0.0, 0.0, 0.0);
	
	color += core(uv);
	color += glow(uv);
	color += rays(uv);
	color += rand(uv) * 0.08;
	
	gl_FragColor = float4(color, 1.0);
            return gl_FragColor;

}


// Vertex Shader
struct VS_INPUT
{
    float3 position	: POSITION;
    float2 texture0     : TEXCOORD0;
};

struct VS_OUTPUT
{
     float4 hposition : POSITION;
     float2 texture0  : TEXCOORD0;
};

VS_OUTPUT myvs( VS_INPUT IN )
{
    VS_OUTPUT OUT;
    if (postfx == 0) {
      OUT.hposition = mul( worldViewProjI, float4(IN.position.x ,IN.position.y ,IN.position.z, 1) ); 
    } else {
      OUT.hposition = float4(IN.position.x ,IN.position.y ,IN.position.z, 1);
    }    
    OUT.texture0 = IN.texture0;
    return OUT;
}
// ---------------------------------------------
technique Start
{
    pass p1  
    {
        VertexShader = compile vs_3_0 myvs();
        PixelShader = compile ps_3_0 main();
    }
}


